#! /usr/bin/python3
import os
import dbus

class License_dbusInterface:

    def __init__(self):
        dbus_name = "com.nfs.license" 
        dbus_path = "/com/nfs/license/Info"
        dbus_iface = "com.nfs.license.Info"

        self.os_id = "os"
        self.product_id = "方德桌面操作系统"
        self.version = "5.0"
        self.license_path = "/etc/licenses.d/os"

        if os.path.exists(self.license_path):
            with open(self.license_path, 'r') as license_file:
                self.os_id = license_file.read()
                if self.os_id == "ED":
                    self.product_id += "(教育版)"

        system_bus = dbus.SystemBus()
        remote_obj = system_bus.get_object(dbus_name, dbus_path)
        self.iface = dbus.Interface(remote_obj, dbus_iface)

    def getLicenseState(self):
        return self.iface.GetLicenseState(self.os_id)

    def showLicenseActivator(self):
        return self.iface.ShowLicenseActivator(self.os_id, self.product_id, self.version)