#! /usr/bin/python3

import os
import threading
from ctypes import *


path_lib = os.popen("dpkg -L nfs-ui-sdk | grep libUiSDK.so").read()
files_lib = path_lib.split("\n")

name_lib = ""
file_ui_sdk = ""

for lib_p in files_lib:
    lib_f = lib_p.split("/")
    lib_f = lib_f[len(lib_f) - 1]
    if lib_f.startswith("libUiSDK.so"):
        index_s = len("libUiSDK.so")
        if len(name_lib) == 0:
            name_lib = lib_f[index_s:]
            file_ui_sdk = lib_p
        elif name_lib < lib_f[index_s:]:
            name_lib = lib_f[index_s:]
            file_ui_sdk = lib_p


lib_ui_sdk = cdll.LoadLibrary(file_ui_sdk)
CFUN_DEF = CFUNCTYPE(None)

lock = threading.Lock()

class Nofity_Send(threading.Thread):
    def __init__(self, title, msg, iconPath, msgConfirm, msgCancel, funConfirm, funCancel, list_notify=[]):
        threading.Thread.__init__(self)
        self.threadID = str(len(list_notify))
        self.title = title
        self.msg = msg
        self.iconPath = iconPath
        self.soundPath = ""
        self.level = "normal"
        if msgConfirm:
            self.msgConfirm = msgConfirm.encode()
        else:
            self.msgConfirm = None
        if msgCancel:
            self.msgCancel = msgCancel.encode()
        else:
            self.msgCancel = None
        if funConfirm:
            self.funConfirm = CFUN_DEF(funConfirm)
        else:
            self.funConfirm = None
        if funCancel:
            self.funCancel = CFUN_DEF(funCancel)
        else:
            self.funCancel = None
    def run(self):
        lock.acquire()
        lib_ui_sdk.us_nofity_send(self.title.encode(), self.msg.encode(), self.iconPath.encode(), self.soundPath.encode(), self.level.encode(), self.msgConfirm, self.msgCancel, self.funConfirm, self.funCancel)
        lock.release()