#!/usr/bin/python3
#-*-coding:UTF-8-*-

##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

import shutil,sys,os,json
from .lib_result import *

#文件删除，如果文件/文件夹存在，进行对应删除工作
def file_delete(filename):
    try:
        if os.path.exists(filename):
            if os.path.isfile(filename):
                os.remove(filename)
            elif os.path.isdir(filename):
                shutil.rmtree(filename)
        return Result(None, None)
    except OSError:
        return Result("file_delete:权限不足，需要管理员权限", None)
    except IOError as e:
        return Result("file_delete:文件处理异常，请检查", None)
    except Exception:
        return Result("file_delete:未知异常，请稍后重试", None)

#从文件中读取json数据
def get_json_from_file(filename):
    try:
        file_obj = open(filename)
        file_data = file_obj.read()
        file_obj.close()
        json_obj = json.loads(file_data)
        return Result(None, json_obj)
    except IOError as e:
        return Result("get_json_from_file:文件处理异常，请检查", None)
    except Exception:
        return Result('get_json_from_file:未知异常，请稍后重试', None)

#将json数据写入文件
def write_json_to_file(patch_json, filename, keybool, indent_num):
    try:
        # json_str = json.dumps(patch_json)
        del_res = file_delete(filename)
        if del_res.getError() != None:
            return del_res
        file_obj = open(filename, 'w')
        file_obj.write(json.dumps(patch_json, sort_keys=keybool, indent=indent_num))
        file_obj.close()
        return Result(None, None)
    except IOError as e:
        return Result("write_json_to_file:文件处理异常，请检查", None)
    except Exception:
        return Result('write_json_to_file:未知异常，请稍后重试', None)

