# -*- coding:utf-8 -*-

##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

from gi.repository import (
    GObject,
    Gdk,
    Gtk,
    Pango,
)
import tempfile

class download_window():
    """docstring for pageGtk"""
    def __init__(self):

        # Second step: Show Main Window
        self.builder = Gtk.Builder()
        self.builder.add_from_file("download.ui")
        self.window = self.builder.get_object("download-notify-window")
        self.download_label = self.builder.get_object('download-content')
        self.viewport1 = self.builder.get_object("download-viewport")
        self.viewport1.set_name("download-viewport")

        self.yes_button = self.builder.get_object("yes")
        self.no_button = self.builder.get_object("no")
        self.yes_button.set_name("yes")
        self.yes_button.get_style_context().add_class("popup_patch_btn")
        self.no_button.get_style_context().add_class("popup_patch_btn")
        self.no_button.set_name("no")
        self.download_content = self.builder.get_object("download-content")
        self.download_content.set_name("download-content")
        self.download_title = self.builder.get_object("download-title")
        self.separator1 = self.builder.get_object("download-separator")
        self.separator1.set_name("download-separator")
        self.download_title.set_name("download-title")
        self.download_label.set_markup('download patch?')

        self.builder.connect_signals(self)

        screen  = Gdk.Screen.get_default()
        css_provider = Gtk.CssProvider()
        css_provider.load_from_path('test.css')
        context = Gtk.StyleContext()
        context.add_provider_for_screen(screen, css_provider,
          Gtk.STYLE_PROVIDER_PRIORITY_USER)

        self.window.set_size_request(300, 130)
        # connect destroy signal on window
        # self.window.connect('destroy', lambda w:Gtk.main_quit())
        # set position
        (self._width, self._height) = self.window.get_size()
        self.window.move(screen.get_width() - self._width, screen.get_height() - self._height)
        # set window above other window
        self.window.set_keep_above(True)
        
        self.window.show_all()
        self.yes_button.hide()

    def on_yes_clicked(self, widget):
        print('yes')
        # self.window.destroy()
        # Gtk.main_quit()

    def on_no_clicked(self, widget):
        print('no')
        # self.window.destroy()
        # Gtk.main_quit()

if __name__ == "__main__":
    logdir = '/home/z/tmp.txt'
    log = tempfile.NamedTemporaryFile(prefix = logdir, delete=False)
    logFile = log.name
    log.writelines("++ Creating directory\n")
    log.flush()
    download_window()
    Gtk.main()
