#!/usr/bin/python3
#-*- coding: utf-8 -*-

##
## Copyright (c) 2016-2021 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##


import gtk_main
import backcheck_update
import check_upgrade


def UnitTest_GetLocalPackageList():
    print("--------UnitTest:gtk_main.get_local_package_list()")
    print("--------Input:none")
    print("--------expected output:Json格式的安装包信息")
    local_package_info_res = gtk_main.get_local_package_list()
    if local_package_info_res.getError():
        print("get local package list fail.")
    else:
        local_packages_info = local_package_info_res.getValue()
        print(local_packages_info)
        print("PASS   :UnitTest:gtk_main.get_local_package_list()")
        print(" ")
 
def UnitTest_GetPidAndProcessName():
    print("--------UnitTest:backcheck_update.get_pid_and_process_name()")
    print("--------Input:none")
    print("--------expected output: JSON格式的进程信息")
    pid_and_process_name = backcheck_update.get_pid_and_process_name();
    print(pid_and_process_name)
    print("PASS   :UnitTest:backcheck_update.get_pid_and_process_name()")
    print(" ")

def UnitTest_GetRegisterStatus():
    print("--------UnitTest:backcheck_update.getRegisterStatus()")
    print("--------Input:none")
    print("--------expected output: 注册状态")   
    status = backcheck_update.getRegisterStatus()
    if status is None:
        print("        注册状态：系统未注册")
    else:
        print("        注册状态：系统已注册")
    print("PASS   :UnitTest:backcheck_update.getRegisterStatus()")
    print(" ")

def UnitTest_GetRemotePatchlist():   
    print("--------UnitTest:backcheck_update.checkmainwindow()")
    print("--------Input:none")
    print("--------expected output: 系统更新主窗体显示状态")   
    status = backcheck_update.checkmainwindow()    
    if status is True:
        print("        系统更新主窗体已显示")
    else:
        print("        系统更新主窗体未显示")
    print("PASS   :backcheck_update.checkmainwindow()")
    print(" ")

def UnitTest_CheckNeedUpgrade():   
    print("--------UnitTest:check_upgrade.check_need_upgrade()")
    print("--------Input:none")
    print("--------expected output: 系统需要更新状态")   
    ret = check_upgrade.check_need_upgrade()
    if ret is 0:
        print("        系统需要更新状态：0")
    elif ret is 1:
        print("        系统需要更新状态：1")
    else:
        print("        系统需要更新状态：2")
    print("PASS   :check_upgrade.check_need_upgrade()")
    print(" ")


if __name__ == "__main__":
   UnitTest_GetLocalPackageList()
   UnitTest_GetPidAndProcessName()
   UnitTest_GetRegisterStatus()
   UnitTest_GetRemotePatchlist()
   UnitTest_CheckNeedUpgrade()
